/********************************************************************************
File: sqlmiddlertools.h
Author: Salas Lopez, Jorge
Date:   27/05/2004
Description: Database Library Tools for postgres v7.2.
Invocation:  Nothing
*********************************************************************************/

/********************************************************************************
   Table of Contents:
   Reusable Functions:
    int GetWriteSet(struct DBType *db, char *writeset);
    int SetWriteSet(struct DBType *db, char *writeset, int length);
    char *SQLDeleteTableDB(char *db, char *table);
    char *SQLExistDBInDBSchema(char *db);
    char *SQLInsertTableDB(char *maxid, char *db, char *table);
    char *SQLLastIDCC();
    char *SQLRecordsDBSchema();
    char *SQLTablesDB();
   Intern Functions:
    ---
   Includes:
    ---
   Source code in this file:
    All
*********************************************************************************/

/********************************************************************************
 Defines  
*********************************************************************************/
#define NAMEDBSCHEMA "middler"

/****************
 *  DEFINITION  *
 ***************/
/********************************************************************************
Reusable Function.
   int GetWriteSet(struct DBType *db, char *writeset);
   Purpose: Get writeset of the last update
   Limitations: Nothing
   Returns: if an error exist return -1
            else return size of writeset
*********************************************************************************/
int GetWriteSet(struct DBType *db, char *writeset);

/********************************************************************************
Reusable Function.
   int SetWriteSet(struct DBType *db, char *writeset, int length);
   Purpose: Get writeset of the last update
   Limitations: Nothing
   Returns: if an error exist return -1
            else return size of writeset
*********************************************************************************/
int SetWriteSet(struct DBType *db, char *writeset, int length);

/********************************************************************************
Reusable Function.
   char *SQLDeleteTableDB(char *db, char *table);
   Purpose: Get sentence sql for delete table in database replicated
   Limitations: Nothing
   Returns: sentence sql -> "insert into conflict_classes values (maxid, 'db', 'table')
*********************************************************************************/
char *SQLDeleteTableDB(char *db, char *table);

/********************************************************************************
Reusable Function.
   char *SQLExistDBInDBSchema(char *db);
   Purpose: Get sentence sql for delete table in database replicated
   Limitations: Nothing
   Returns: sentence sql -> "insert into conflict_classes values (maxid, 'db', 'table')
*********************************************************************************/
char *SQLExistDBInDBSchema(char *db);

/********************************************************************************
Reusable Function.
   char *SQLInsertTableDB(char *maxid, char *db, char *table);
   Purpose: Get sentence sql for insert table in database replicated
   Limitations: Nothing
   Returns: sentence sql -> "insert into conflict_classes values (maxid, 'db', 'table')
*********************************************************************************/
char *SQLInsertTableDB(char *maxid, char *db, char *table);

/********************************************************************************
Reusable Function.
   char *SQLLastIDCC();
   Purpose: Get sentence sql for get the last id_cc in database schema
   Limitations: Nothing
   Returns: sentence sql -> "select MAX(id_cc) from conflict_classes"
*********************************************************************************/
char *SQLLastIDCC();

/********************************************************************************
Reusable Function.
   char *SQLRecordsDBSchema();
   Purpose: Get sentence sql for get records of database schema
   Limitations: Nothing
   Returns: sentence sql -> "select dbname, tablename, id_cc from conflict_classes"
*********************************************************************************/
char *SQLRecordsDBSchema();

/********************************************************************************
Reusable Function.
   char *SQLTablesDB();
   Purpose: Get sentence sql for get all tables in replicated database
   Limitations: Nothing
   Returns: sentence sql -> "select relname from pg_class where relkind = 'r'"
*********************************************************************************/
char *SQLTablesDB();
