/*****************************************************************************
File: tools.h
Author: Salas López, Jorge		
Date:   29/03/2004
Description: Header of tools.c
Invocation:  ---
*****************************************************************************/

/*****************************************************************************	  
   Table of Contents:
   Reusable Functions:      
	  int Append(char **str_1, char *str_2);
	  int Append_withSpace(char **str_1, char *str_2);	  


   Intern Functions:
      ---
   Includes:
	    --- 
   Source code in this file:
      All
*********************************************************************************/

/********************************************************************************
Defines
*********************************************************************************/
#define EOF_SIZE 1
#define TRUE  1
#define FALSE 0 

#define Malloc(__ptr, __struct)                                   \
  if ( !(__ptr = (__struct*) malloc( sizeof(__struct) ))) {       \
    printf ( "%s# %d # Out of memory.\n", __FILE__, __LINE__ );   \
    return FALSE;                                               \
  }

#define MallocSize(__ptr, __struct, __size)                           \
  if ( !(__ptr = (__struct*) malloc( sizeof(__struct) * __size) )) {  \
    printf ( "%s# %d # Out of memory.\n", __FILE__, __LINE__ );       \
    return FALSE;                                                   \
  }

#define Free(__ptr)                                               \
  if (__ptr) {                                                    \
    free(__ptr);                                                  \
    __ptr = NULL;                                                 \
  }

#define error( __expr )                                                               \
  if ( __expr ) {                                                                      \
   printf ( "%s# %d ## Error evaluating %s returning\n", __FILE__, __LINE__, __expr ); \
   return FALSE;                                                                       \
  }

/****************
 *	DEFINITION	*
 ***************/

/********************************************************************************
Reusable Function.
   int Append(char **str_1, char *str_2);
   Purpose: Concat two string.
   Limitations: Nothing
   Returns: if an error occurs return FALSE
            else return TRUE
*********************************************************************************/
int Append(char **str_1, char *str_2);

/********************************************************************************
Reusable Function.
   int Append_withSpace(char **str_1, char *str_2);
   Purpose: Concat two string adding one space between both.
   Limitations: Nothing
   Returns: if an error occurs return FALSE
            else return TRUE
*********************************************************************************/
int Append_withSpace(char **str_1, char *str_2);
